# Routes

A route is a rule that maps an incoming request to a specific backend service.

This tag groups all operations for routes.

## Retrieve all Routes

> This endpoint enables retrieving all Routes using\
> pagination and optional filters.<br>

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - API Gateway","version":"0.0.1"},"tags":[{"name":"Routes","description":"A route is a rule that maps an incoming request to a specific backend service.\n\nThis tag groups all operations for routes.\n"}],"servers":[{"url":"https://apigateway.de-txl.ionos.com","description":"Production de-txl"},{"url":"https://apigateway.gb-lhr.ionos.com","description":"Production gb-lhr"},{"url":"https://apigateway.fr-par.ionos.com","description":"Production fr-par"},{"url":"https://apigateway.es-vit.ionos.com","description":"Production es-vit"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"parameters":{"paginationOffset":{"name":"offset","in":"query","description":"The first element (of the total list of elements) to include in the response. Use this parameter together with the limit for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":0,"minimum":0}},"paginationLimit":{"name":"limit","in":"query","description":"The maximum number of elements to return. Use this parameter together with the offset for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":100,"minimum":1,"maximum":1000}}},"schemas":{"RouteReadList":{"allOf":[{"type":"object","required":["id","type","href"],"properties":{"id":{"description":"ID of the list of Route resources.","type":"string","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["collection"]},"href":{"description":"The URL of the list of Route resources.","type":"string"},"items":{"description":"The list of Route resources.","type":"array","items":{"$ref":"#/components/schemas/RouteRead"}}}},{"$ref":"#/components/schemas/Pagination"}]},"RouteRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Route.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["route"]},"href":{"description":"The URL of the Route.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithEndpoint"},"properties":{"$ref":"#/components/schemas/Route"}}},"MetadataWithEndpoint":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["publicEndpoint"],"properties":{"publicEndpoint":{"type":"string","description":"The public endpoint of the API Gateway instance.\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the object. The status can be:\n* `AVAILABLE` - resource exists and is healthy.\n* `PROVISIONING` - resource is being created or updated.\n* `DESTROYING` - delete command was issued, the resource is being deleted.\n* `FAILED` - resource failed, details in `failureMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The message of the failure if the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Route":{"type":"object","description":"A route is a rule that maps an incoming request to a specific backend service.\n","required":["name","type","paths","methods","upstreams"],"properties":{"name":{"type":"string","minLength":1,"maxLength":25,"pattern":"^[a-zA-Z0-9 _-]+$","description":"The name of the route."},"type":{"type":"string","description":"This field specifies the protocol used by the ingress to route traffic to the backend service.","default":"http"},"paths":{"type":"array","minItems":1,"items":{"type":"string","format":"path"},"description":"The paths that the route should match.\n"},"methods":{"type":"array","items":{"type":"string","enum":["GET","POST","PUT","DELETE","PATCH","OPTIONS","HEAD","CONNECT","TRACE"]},"description":"The HTTP methods that the route should match.\n"},"websocket":{"type":"boolean","default":false,"description":"To enable websocket support."},"upstreams":{"type":"array","minItems":1,"items":{"required":["scheme","loadbalancer","host","port"],"type":"object","properties":{"scheme":{"type":"string","description":"The target URL of the upstream.","enum":["http","https","grpc","grpcs"],"default":"http"},"loadbalancer":{"type":"string","description":"The load balancer algorithm.","default":"roundrobin"},"host":{"type":"string","description":"The host of the upstream. Field is validated as hostname [according to RFC1123](https://pkg.go.dev/github.com/go-playground/validator/v10#hdr-Hostname_RFC_1123).","format":"host"},"port":{"type":"integer","description":"The port of the upstream.","default":80,"minimum":1,"maximum":65535},"weight":{"type":"integer","description":"Weight with which to split traffic to the upstream.","default":100}}}},"cache":{"$ref":"#/components/schemas/Cache"}}},"Cache":{"type":"object","description":"The cache configuration for the API Gateway instance. The TTL is 60 seconds.\n","properties":{"enable":{"type":"boolean","default":false,"description":"To enable caching."},"httpMethods":{"type":"array","items":{"type":"string","enum":["GET","POST","HEAD"]},"description":"The HTTP methods that the cache should match.\n"},"httpCodes":{"type":"array","items":{"type":"integer","minimum":200,"maximum":599},"description":"The HTTP status codes that the cache should match.\n"}}},"Pagination":{"required":["offset","limit","_links"],"description":"Pagination information. The offset and limit parameters are used to\nnavigate the list of elements. The _links object contains URLs to\nnavigate the different pages.\n","type":"object","properties":{"offset":{"$ref":"#/components/schemas/Offset"},"limit":{"$ref":"#/components/schemas/Limit"},"_links":{"$ref":"#/components/schemas/Links"}}},"Offset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"readOnly":true},"Limit":{"description":"The limit specified in the request (if none was specified, use the\nendpoint's default pagination limit).\n","type":"integer","minimum":0,"readOnly":true},"Links":{"description":"URLs to navigate the different pages. As of now we always only return a\nsingle page.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/gateways/{apigatewayId}/routes":{"get":{"operationId":"apigatewaysRoutesGet","summary":"Retrieve all Routes","description":"This endpoint enables retrieving all Routes using\npagination and optional filters.\n","parameters":[{"name":"apigatewayId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Gateway."},{"$ref":"#/components/parameters/paginationOffset"},{"$ref":"#/components/parameters/paginationLimit"},{"name":"orderBy","in":"query","description":"The field to order the results by. If not provided, the results will be ordered by the default field.","schema":{"type":"string","default":"-createdDate","enum":["-createdDate","-lastModifiedDate","-name","name","createdDate","lastModifiedDate"]}}],"tags":["Routes"],"responses":{"200":{"description":"Returned all requested Routes successfully.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RouteReadList"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Create Route

> Creates a new Route.\
> \
> The full Route needs to be provided to create the object.\
> Optional data will be filled with defaults or left empty.<br>

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - API Gateway","version":"0.0.1"},"tags":[{"name":"Routes","description":"A route is a rule that maps an incoming request to a specific backend service.\n\nThis tag groups all operations for routes.\n"}],"servers":[{"url":"https://apigateway.de-txl.ionos.com","description":"Production de-txl"},{"url":"https://apigateway.gb-lhr.ionos.com","description":"Production gb-lhr"},{"url":"https://apigateway.fr-par.ionos.com","description":"Production fr-par"},{"url":"https://apigateway.es-vit.ionos.com","description":"Production es-vit"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"RouteCreate":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/Route"}}},"Route":{"type":"object","description":"A route is a rule that maps an incoming request to a specific backend service.\n","required":["name","type","paths","methods","upstreams"],"properties":{"name":{"type":"string","minLength":1,"maxLength":25,"pattern":"^[a-zA-Z0-9 _-]+$","description":"The name of the route."},"type":{"type":"string","description":"This field specifies the protocol used by the ingress to route traffic to the backend service.","default":"http"},"paths":{"type":"array","minItems":1,"items":{"type":"string","format":"path"},"description":"The paths that the route should match.\n"},"methods":{"type":"array","items":{"type":"string","enum":["GET","POST","PUT","DELETE","PATCH","OPTIONS","HEAD","CONNECT","TRACE"]},"description":"The HTTP methods that the route should match.\n"},"websocket":{"type":"boolean","default":false,"description":"To enable websocket support."},"upstreams":{"type":"array","minItems":1,"items":{"required":["scheme","loadbalancer","host","port"],"type":"object","properties":{"scheme":{"type":"string","description":"The target URL of the upstream.","enum":["http","https","grpc","grpcs"],"default":"http"},"loadbalancer":{"type":"string","description":"The load balancer algorithm.","default":"roundrobin"},"host":{"type":"string","description":"The host of the upstream. Field is validated as hostname [according to RFC1123](https://pkg.go.dev/github.com/go-playground/validator/v10#hdr-Hostname_RFC_1123).","format":"host"},"port":{"type":"integer","description":"The port of the upstream.","default":80,"minimum":1,"maximum":65535},"weight":{"type":"integer","description":"Weight with which to split traffic to the upstream.","default":100}}}},"cache":{"$ref":"#/components/schemas/Cache"}}},"Cache":{"type":"object","description":"The cache configuration for the API Gateway instance. The TTL is 60 seconds.\n","properties":{"enable":{"type":"boolean","default":false,"description":"To enable caching."},"httpMethods":{"type":"array","items":{"type":"string","enum":["GET","POST","HEAD"]},"description":"The HTTP methods that the cache should match.\n"},"httpCodes":{"type":"array","items":{"type":"integer","minimum":200,"maximum":599},"description":"The HTTP status codes that the cache should match.\n"}}},"RouteRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Route.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["route"]},"href":{"description":"The URL of the Route.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithEndpoint"},"properties":{"$ref":"#/components/schemas/Route"}}},"MetadataWithEndpoint":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["publicEndpoint"],"properties":{"publicEndpoint":{"type":"string","description":"The public endpoint of the API Gateway instance.\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the object. The status can be:\n* `AVAILABLE` - resource exists and is healthy.\n* `PROVISIONING` - resource is being created or updated.\n* `DESTROYING` - delete command was issued, the resource is being deleted.\n* `FAILED` - resource failed, details in `failureMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The message of the failure if the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/gateways/{apigatewayId}/routes":{"post":{"operationId":"apigatewaysRoutesPost","summary":"Create Route","tags":["Routes"],"description":"Creates a new Route.\n\nThe full Route needs to be provided to create the object.\nOptional data will be filled with defaults or left empty.\n","parameters":[{"name":"apigatewayId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Gateway."}],"requestBody":{"description":"Route to create.","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RouteCreate"}}}},"responses":{"201":{"description":"Route successfully created.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RouteRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Retrieve Route

> Returns the Route by ID.

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - API Gateway","version":"0.0.1"},"tags":[{"name":"Routes","description":"A route is a rule that maps an incoming request to a specific backend service.\n\nThis tag groups all operations for routes.\n"}],"servers":[{"url":"https://apigateway.de-txl.ionos.com","description":"Production de-txl"},{"url":"https://apigateway.gb-lhr.ionos.com","description":"Production gb-lhr"},{"url":"https://apigateway.fr-par.ionos.com","description":"Production fr-par"},{"url":"https://apigateway.es-vit.ionos.com","description":"Production es-vit"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"RouteRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Route.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["route"]},"href":{"description":"The URL of the Route.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithEndpoint"},"properties":{"$ref":"#/components/schemas/Route"}}},"MetadataWithEndpoint":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["publicEndpoint"],"properties":{"publicEndpoint":{"type":"string","description":"The public endpoint of the API Gateway instance.\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the object. The status can be:\n* `AVAILABLE` - resource exists and is healthy.\n* `PROVISIONING` - resource is being created or updated.\n* `DESTROYING` - delete command was issued, the resource is being deleted.\n* `FAILED` - resource failed, details in `failureMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The message of the failure if the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Route":{"type":"object","description":"A route is a rule that maps an incoming request to a specific backend service.\n","required":["name","type","paths","methods","upstreams"],"properties":{"name":{"type":"string","minLength":1,"maxLength":25,"pattern":"^[a-zA-Z0-9 _-]+$","description":"The name of the route."},"type":{"type":"string","description":"This field specifies the protocol used by the ingress to route traffic to the backend service.","default":"http"},"paths":{"type":"array","minItems":1,"items":{"type":"string","format":"path"},"description":"The paths that the route should match.\n"},"methods":{"type":"array","items":{"type":"string","enum":["GET","POST","PUT","DELETE","PATCH","OPTIONS","HEAD","CONNECT","TRACE"]},"description":"The HTTP methods that the route should match.\n"},"websocket":{"type":"boolean","default":false,"description":"To enable websocket support."},"upstreams":{"type":"array","minItems":1,"items":{"required":["scheme","loadbalancer","host","port"],"type":"object","properties":{"scheme":{"type":"string","description":"The target URL of the upstream.","enum":["http","https","grpc","grpcs"],"default":"http"},"loadbalancer":{"type":"string","description":"The load balancer algorithm.","default":"roundrobin"},"host":{"type":"string","description":"The host of the upstream. Field is validated as hostname [according to RFC1123](https://pkg.go.dev/github.com/go-playground/validator/v10#hdr-Hostname_RFC_1123).","format":"host"},"port":{"type":"integer","description":"The port of the upstream.","default":80,"minimum":1,"maximum":65535},"weight":{"type":"integer","description":"Weight with which to split traffic to the upstream.","default":100}}}},"cache":{"$ref":"#/components/schemas/Cache"}}},"Cache":{"type":"object","description":"The cache configuration for the API Gateway instance. The TTL is 60 seconds.\n","properties":{"enable":{"type":"boolean","default":false,"description":"To enable caching."},"httpMethods":{"type":"array","items":{"type":"string","enum":["GET","POST","HEAD"]},"description":"The HTTP methods that the cache should match.\n"},"httpCodes":{"type":"array","items":{"type":"integer","minimum":200,"maximum":599},"description":"The HTTP status codes that the cache should match.\n"}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/gateways/{apigatewayId}/routes/{routeId}":{"get":{"operationId":"apigatewaysRoutesFindById","summary":"Retrieve Route","tags":["Routes"],"description":"Returns the Route by ID.","parameters":[{"name":"apigatewayId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Gateway."},{"name":"routeId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Route."}],"responses":{"200":{"description":"Getting Route was successful.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RouteRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Ensure Route

> Ensures that the Route with the provided ID is created or modified.\
> The full Route needs to be provided to ensure\
> (either update or create) the Route. Non present data will\
> only be filled with defaults or left empty, but not take\
> previous values into consideration.<br>

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - API Gateway","version":"0.0.1"},"tags":[{"name":"Routes","description":"A route is a rule that maps an incoming request to a specific backend service.\n\nThis tag groups all operations for routes.\n"}],"servers":[{"url":"https://apigateway.de-txl.ionos.com","description":"Production de-txl"},{"url":"https://apigateway.gb-lhr.ionos.com","description":"Production gb-lhr"},{"url":"https://apigateway.fr-par.ionos.com","description":"Production fr-par"},{"url":"https://apigateway.es-vit.ionos.com","description":"Production es-vit"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"RouteEnsure":{"type":"object","required":["id","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Route.","format":"uuid"},"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/Route"}}},"Route":{"type":"object","description":"A route is a rule that maps an incoming request to a specific backend service.\n","required":["name","type","paths","methods","upstreams"],"properties":{"name":{"type":"string","minLength":1,"maxLength":25,"pattern":"^[a-zA-Z0-9 _-]+$","description":"The name of the route."},"type":{"type":"string","description":"This field specifies the protocol used by the ingress to route traffic to the backend service.","default":"http"},"paths":{"type":"array","minItems":1,"items":{"type":"string","format":"path"},"description":"The paths that the route should match.\n"},"methods":{"type":"array","items":{"type":"string","enum":["GET","POST","PUT","DELETE","PATCH","OPTIONS","HEAD","CONNECT","TRACE"]},"description":"The HTTP methods that the route should match.\n"},"websocket":{"type":"boolean","default":false,"description":"To enable websocket support."},"upstreams":{"type":"array","minItems":1,"items":{"required":["scheme","loadbalancer","host","port"],"type":"object","properties":{"scheme":{"type":"string","description":"The target URL of the upstream.","enum":["http","https","grpc","grpcs"],"default":"http"},"loadbalancer":{"type":"string","description":"The load balancer algorithm.","default":"roundrobin"},"host":{"type":"string","description":"The host of the upstream. Field is validated as hostname [according to RFC1123](https://pkg.go.dev/github.com/go-playground/validator/v10#hdr-Hostname_RFC_1123).","format":"host"},"port":{"type":"integer","description":"The port of the upstream.","default":80,"minimum":1,"maximum":65535},"weight":{"type":"integer","description":"Weight with which to split traffic to the upstream.","default":100}}}},"cache":{"$ref":"#/components/schemas/Cache"}}},"Cache":{"type":"object","description":"The cache configuration for the API Gateway instance. The TTL is 60 seconds.\n","properties":{"enable":{"type":"boolean","default":false,"description":"To enable caching."},"httpMethods":{"type":"array","items":{"type":"string","enum":["GET","POST","HEAD"]},"description":"The HTTP methods that the cache should match.\n"},"httpCodes":{"type":"array","items":{"type":"integer","minimum":200,"maximum":599},"description":"The HTTP status codes that the cache should match.\n"}}},"RouteRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Route.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["route"]},"href":{"description":"The URL of the Route.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithEndpoint"},"properties":{"$ref":"#/components/schemas/Route"}}},"MetadataWithEndpoint":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["publicEndpoint"],"properties":{"publicEndpoint":{"type":"string","description":"The public endpoint of the API Gateway instance.\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the object. The status can be:\n* `AVAILABLE` - resource exists and is healthy.\n* `PROVISIONING` - resource is being created or updated.\n* `DESTROYING` - delete command was issued, the resource is being deleted.\n* `FAILED` - resource failed, details in `failureMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The message of the failure if the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Conflict":{"description":"### Conflict\nThe UUID is already taken by another party, follow the guides to generate UUIDs uniquely.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/gateways/{apigatewayId}/routes/{routeId}":{"put":{"operationId":"apigatewaysRoutesPut","summary":"Ensure Route","tags":["Routes"],"description":"Ensures that the Route with the provided ID is created or modified.\nThe full Route needs to be provided to ensure\n(either update or create) the Route. Non present data will\nonly be filled with defaults or left empty, but not take\nprevious values into consideration.\n","parameters":[{"name":"apigatewayId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Gateway."},{"name":"routeId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Route."}],"requestBody":{"description":"update Route","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RouteEnsure"}}}},"responses":{"200":{"description":"Route successfully updated.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RouteRead"}}}},"201":{"description":"Route successfully ensured.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RouteRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Delete Route

> Deletes the specified Route.

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - API Gateway","version":"0.0.1"},"tags":[{"name":"Routes","description":"A route is a rule that maps an incoming request to a specific backend service.\n\nThis tag groups all operations for routes.\n"}],"servers":[{"url":"https://apigateway.de-txl.ionos.com","description":"Production de-txl"},{"url":"https://apigateway.gb-lhr.ionos.com","description":"Production gb-lhr"},{"url":"https://apigateway.fr-par.ionos.com","description":"Production fr-par"},{"url":"https://apigateway.es-vit.ionos.com","description":"Production es-vit"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}},"schemas":{"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}}},"paths":{"/gateways/{apigatewayId}/routes/{routeId}":{"delete":{"operationId":"apigatewaysRoutesDelete","summary":"Delete Route","tags":["Routes"],"description":"Deletes the specified Route.","parameters":[{"name":"apigatewayId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Gateway."},{"name":"routeId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Route."}],"responses":{"202":{"description":"Deleting Route was successful."},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```
